package aexp.btdetect;

import android.app.ListActivity;
import android.app.NotificationManager;
import android.content.Context;
import android.content.Intent;
import android.content.ComponentName;
import android.os.Bundle;
import android.os.Handler;
import android.view.Menu;
import android.view.Menu.Item;
import android.widget.ArrayAdapter;
import android.util.Log;
import java.util.List;
import java.util.HashMap;
import java.util.ArrayList;

public class BtDetect extends ListActivity {
    public static final int SCAN_ID = Menu.FIRST;
    static final String LOG_TAG = "BTDETECT";
    private Handler uiHandler = new Handler();
    private static BtDetect appRef = null;
    private HashMap btAddressMap = null;
    ArrayAdapter<String> notes = null;

    /** Called with the activity is first created. */
    @Override
    public void onCreate(Bundle icicle) {
      super.onCreate(icicle);
      setContentView(R.layout.device_list);
      notes = new ArrayAdapter<String>( this, R.layout.device_row );
      setListAdapter( notes );
	  appRef = this;
    }

    @Override
    protected void onDestroy() {
	  super.onDestroy();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
      boolean result = super.onCreateOptionsMenu(menu);
      menu.add(0, SCAN_ID, R.string.scan_devices );
      return result;
    }

    @Override
    public boolean onOptionsItemSelected(Item item) {
        switch (item.getId()) {
        case SCAN_ID:
				startBTScan();
                break;
        }
        return super.onOptionsItemSelected(item);
    }

    public static BtDetect getApp() {
	  return appRef;
	}

    public void btEvent( String action, Bundle extras ) {
      NotificationManager nm = (NotificationManager)
			getSystemService( Context.NOTIFICATION_SERVICE);
	  Log.d( LOG_TAG, "Action = "+action );
	  if( action.equals( "org.bluez.intent.action.DISCOVERY_STARTED" ) ) {
        nm.notifyWithText(123, "Discovery started",
                    NotificationManager.LENGTH_LONG, null );
		btAddressMap = new HashMap();
        notes = new ArrayAdapter<String>(
				this, R.layout.device_row );
        setListAdapter( notes );
	  } else
	  if( action.equals( "org.bluez.intent.action.DISCOVERY_COMPLETED" ) ) {			
        nm.notifyWithText(123, "Discovery completed",
                    NotificationManager.LENGTH_LONG, null );
		btAddressMap = null;
	  } else
	  if( action.equals( "org.bluez.intent.action.REMOTE_DEVICE_FOUND" ) ) {
		String address = extras.getString( "address" );
		if( address == null )
			Log.e( LOG_TAG, "REMOTE_DEVICE_FOUND, address==null!" );
		else {
		  btAddressMap.put( address,new Integer( notes.getCount() ) );
		  notes.addObject( address );
		} 
	  } else
	  if( action.equals( "org.bluez.intent.action.REMOTE_NAME_UPDATED" ) ) {
		String address = extras.getString( "address" );
		String name = extras.getString( "name" );
		if( ( address == null ) || ( name == null ) )
			Log.e( LOG_TAG, "REMOTE_NAME_UPDATED, address==null||name==null" );
		else {
		  Integer ap = (Integer)btAddressMap.get( address );
		  if( ap == null )
			Log.e( LOG_TAG,"REMOTE_NAME_UPDATED, "+address+" is not found in the address map" );
		  else {
			int pos = ap.intValue();
			notes.removeObject( address );
			String nameStr = name+" ("+address+")";
			notes.insertObject( nameStr,pos );
//			notes.addObject( nameStr );
		  }
		} 
	  }
	}

    private void startBTScan() {
	  Intent i = new Intent();
	  i.setClassName( "aexp.btdetect", 
			"aexp.btdetect.BtDetectSimulatorService" );
	  Bundle b = new Bundle();
	  startService( i,b );
	}

/*
        uiHandler.post(new Runnable() {
           public void run() {
	  	     TextView t = (TextView)findViewById(R.id.invoke_result);
		     t.setText( textToSet );
           }
        });
*/

}
